unit Nastroi;

interface
 Uses Classes,DBTables;
 const PathData0='c:\bvista\back\';
       PathData   : string[80]='c:\bvista\back\';      {  }
       PathDataDbf: string[80]='c:\bvista\backDbf\';
       PathDataLoc: string[80]='c:\bvista\backLoc\';
       PathDataDil: string[80]='c:\bvista\backLoc\';
       NamePredlog: string[80]='c:\bvista\backLoc\predlog.db';
       DayDelta   : real = 3.0;
       PeriodDelta: real = 30.0;
       DayInYear  : integer = 365;
       cValuta    = 10000;
       cRubl      = 100;
       cgMesto    =-999;
       ComissBrok : real = 0;
 function  FindInList   (nn:longint ; Lst: tList):longint;
 function  FindInListE  (rr:extended; Lst: tList):longint;
 function  FindInListMin(nn:longint ; Lst: tList):longint;
 procedure InitPathData;

 function  GetNewPos(vi:Longint):Longint;
 function  GetMaxPos(qW:TQuery;sB,sF:string):longint;

 var CL_W,CL_H:integer;
     KodID,KodST    : integer;
     mKodST   : LongInt;
     sKodID   : string[2];

     Myss,MySS2 : string;
     PassID  : string[10]; { }
     DolgID  : string[15];

implementation
 uses SysUtils,IniFiles,DB,WinProcs;

 procedure InitPathData;
 var
  IniFile: TIniFile;
  sl,s2 : TStringList;
  s   : string;
  jj  : integer;

  procedure SetPathAlias(vs:string;var vPath:string;vcPath:string);
  var fnd : boolean;
      i,j : longint;
  begin
    i:=0; fnd:=false;
    while (i<sl.Count) and not fnd do begin
      s:=sl[i];
      for j:=1 to Length(s) do s[j]:=Upcase(s[j]);
      fnd:=s=vs;
      if not fnd then inc(i)
    end;
    if fnd then begin
      s2.Clear;
      Session.GetAliasParams(vs,s2);
      vPath:=Copy(s2[0],6,Length(s2[0]));
    end else
      vPath:=ExtractFilePath(Paramstr(0))+vcPath;
  end;
 begin
  sl :=TStringList.Create;s2 :=TStringList.Create;
  Session.GetAliasNames(sl);
  SetPathAlias('BACK'   ,PathData   ,'Back'   );
  SetPathAlias('BACKDBF',PathDataDbf,'BackDbf');
  SetPathAlias('BACKLOC',PathDataLoc,'BackLoc');
  SetPathAlias('BACKDIL',PathDataDil,'BackDil');
  sl.free; s2.free;
  IniFile    := TIniFile.Create(PathDataDbf+'\BACK.INI');
  if IniFile<>Nil then begin
    DayDelta   :=IniFile.ReadInteger('RASCHET','DayDelta',3);
    PeriodDelta:=IniFile.ReadInteger('RASCHET','PeriodDelta',30);
    DayInYear  :=IniFile.ReadInteger('RASCHET','DayInYear',365);
    KodST      :=IniFile.ReadInteger('KOD_ST','KODST',0);
    s          :=IniFile.ReadString ('Const','ComissBrok','0');
    val(s,ComissBrok,jj);
    if jj>0 then ComissBrok := 0.0;
    if (KodST<0) or (KodST>21) then KodST:=0;
  end else begin
    DayDelta:=3; PeriodDelta:=30; DayInYear:=365; KodST:=0;
  end;
  mKodST:=100000000;
  IniFile.Free;
  (*
  byte(s[0]) :=GetWindowsDirectory(@S[1],144);
  IniFile    := TIniFile.Create(s+'\WIN.INI');
  if IniFile<>Nil then
    ShortDateformat:=IniFile.ReadString('Intl','sShortDate',ShortDateFormat);
  IniFile.Free;
  *)
  NamePredlog:=PathDataLoc+'\predlog.db';
 end ;

function FindInList;
Var fnd: boolean;
    ii : longint;
begin
  fnd:=false;ii:=0;
  if (Lst<>Nil)and(Lst.count>0) then
    while not fnd and (ii<Lst.count) do begin
      fnd:=nn=longint(Lst.Items[ii]^);
      if not fnd then inc(ii);
    end;
  if fnd then result:=ii else
    if Lst.count=0 then result:=-1 else result:=0;
end;

function FindInListMin;
Var fnd: boolean;
    ii,jj : longint;
begin
  fnd:=false;ii:=0;
  if (Lst<>Nil)and(Lst.count>0) then
    while not fnd and (ii<Lst.count) do begin
      jj:=longint(Lst.Items[ii]^);
      fnd:=nn=jj;
      if not fnd then inc(ii);
    end;
  if fnd then result:=ii else result:=-1;
end;

function FindInListE;
Var fnd: boolean;
    ii : longint;
begin
  fnd:=false;ii:=0;
  if (Lst<>Nil)and(Lst.count>0) then
    while not fnd and (ii<Lst.count) do begin
      fnd:=rr=Extended(Lst.Items[ii]^);
      if not fnd then inc(ii);
    end;
  if fnd then result:=ii else
    if Lst.count=0 then result:=-1 else result:=0;
end;

function GetNewPos(vi:Longint):Longint;
begin
  Result:=KodST*mKodST+((vi mod mKodST)+1);
end;

function GetMaxPos(qW:TQuery;sB,sF:string):longint;
begin
  Result:=0;
  try
    qW.SQL.Clear;
    qW.SQL.Add('select Max('+sF+') from "'+sB+'" where '+sF+'>=:a0 and '+sF+'<:a1');
    qW.Params[0].AsInteger:=KodST*mKodST;
    qW.Params[1].AsInteger:=(KodST+1)*mKodST;
    qW.Open;
    Result:=qW.Fields[0].AsInteger;
  finally qW.Close end;
end;

end.
